#2567 closed defect (fixed)

m68k/mrm332: linker script update (add KEEP() sections)

Reported by: Joel Sherrill Owned by: Joel Sherrill
Priority: normal Milestone: Indefinite
Component: bsps Version: 5
Severity: normal Keywords: function sections, KEEP
Cc: Blocked By:
Blocking:

Description

This BSP's linker script does not include KEEP() directives and thus cannot have per-function and per-data element section support enabled.

The preferred solution is to convert the BSP to use a shared base linker script. The acceptable solution is to add the proper KEEP directives to the existing linker script(s).

Shared linker scripts for the arm, m68k, and sparc have the proper KEEP sections and can serve as examples.

Change History (5)

comment:1 Changed on Feb 15, 2017 at 1:49:47 PM by Sebastian Huber

Owner: set to Joel Sherrill
Status: newassigned

comment:2 Changed on May 11, 2017 at 7:31:02 AM by Sebastian Huber

Milestone: 4.124.12.0

comment:3 Changed on Aug 24, 2017 at 5:59:58 AM by Sebastian Huber

Milestone: 4.12.0Indefinite

comment:4 Changed on Sep 14, 2018 at 6:59:10 PM by Joel Sherrill

Keywords: function sections KEEP added

comment:5 Changed on Nov 29, 2018 at 10:22:24 PM by Shashvat Jain <shashvatjain2002@…>

Resolution: fixed
Status: assignedclosed

In 8b28fdd/rtems:

m68k/mrm332:Add per-section compilation and linking support (GCI 2018)

The size of the sample executables without this option were:

text data bss dec hex filename

172384 2096 14512 188992 2e240 ./capture.exe

70848 1136 11568 83552 14660 ./base_sp.exe

101728 1504 11728 114960 1c110 ./hello.exe
217744 6016 18336 242096 3b1b0 ./loopback.exe

57968 1008 8416 67392 10740 ./minimum.exe
93952 1616 11696 107264 1a300 ./nsecs.exe

166272 1904 12304 180480 2c100 ./paranoia.exe
358240 12032 41136 411408 64710 ./pppd.exe

73104 1168 11600 85872 14f70 ./ticker.exe
73264 1120 15472 89856 15f00 ./unlimited.exe

The size of the sample executables with this option were:

text data bss dec hex filename

158976 2096 14464 175536 2adb0 ./capture.exe

66304 1136 11488 78928 13450 ./base_sp.exe
92912 1504 11680 106096 19e70 ./hello.exe

202240 6000 18272 226512 374d0 ./loopback.exe

53296 992 8336 62624 f4a0 ./minimum.exe
88032 1616 11600 101248 18b80 ./nsecs.exe

157760 1888 12272 171920 29f90 ./paranoia.exe
346080 12032 41056 399168 61740 ./pppd.exe

68304 1168 11520 80992 13c60 ./ticker.exe
71312 1104 15440 87856 15730 ./unlimited.exe

Closes #2567

Note: See TracTickets for help on using tickets.